.586
.model  	flat, STDCALL
option   	casemap: none   ; Case sensitive

include IPT ES 1.inc

.code

ErrorHandler:

;KillSehFrame
;invoke SetUnhandledExceptionFilter,EXCEPTION_CONTINUE_EXECUTION 
;InstSehFrame <OFFSET ErrorHandler>
	

INVOKE MessageBox,0,0,0,MB_OK
;invoke	DlgProc,NULL,NULL,NULL,NULL
mov	eax,1
ret

start:
;	InstSehFrame <OFFSET ErrorHandler>
invoke SetUnhandledExceptionFilter,addr ErrorHandler 
	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,MainDLG,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL	TV1,TV2,TV3:dword
	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		invoke	LoadIcon,hInstance,100
		invoke	SendMessage,hWin,WM_SETICON,ICON_BIG,eax
		invoke	DoListStartup,hWin
		invoke	ReadDataFile
	.elseif eax==WM_COMMAND
		.if wParam == New_Record
			invoke SysAllocStringByteLen,100,0
			mov	TV1,eax
			invoke	SysAllocStringByteLen,100,0
			mov	TV2,eax
			invoke	SendDlgItemMessage,hWin,IDC_EDT1,WM_GETTEXT,100,TV1
			invoke	SendDlgItemMessage,hWin,IDC_EDT2,WM_GETTEXT,100,TV2
			invoke	AddListItem,TV1,TV2
			invoke	NewEntry,TV1,TV2
			invoke	SysFreeString,TV1
			invoke	SysFreeString,TV2
		.endif
	.elseif eax==WM_CLOSE
	 	invoke	UnmapViewOfFile,DataHandle
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

AddListItem proc txt1:dword,txt2:dword
LOCAL    lvi:LV_ITEM
mov     lvi.imask, LVIF_TEXT or LVIF_PARAM
push    0
pop     lvi.iItem
push    0
pop     lvi.lParam
mov     lvi.iSubItem, 0
push	txt1
pop    	lvi.pszText
INVOKE     SendMessage, Item_List, LVM_INSERTITEM, 0, addr lvi

mov     lvi.imask, LVIF_TEXT
inc     lvi.iSubItem
push	txt2
pop    	lvi.pszText
INVOKE     SendMessage, Item_List, LVM_SETITEM, 0, addr lvi

;invoke	SendMessage, Item_List, LVM_UPDATE,0,0
	ret

AddListItem endp

NewEntry proc Name1:dword,Name2:dword
mov		edx,DataHandle
assume	edx:ptr DataHeader
mov		eax,[edx].FirstHeader
.if		eax == 0
	mov		eax,sizeof DataHeader+1
	mov		[edx].FirstHeader,eax
.endif
mov		eax,[edx].FirstHeader
add		edx,eax
assume	edx:ptr EntryHeader
;Find the last Entry ....
@@:
mov		eax,[edx].NextEntry

push	eax
.if		eax != 0
	pop	eax
	add	edx,eax
	jmp	@b
.endif
;mov		ecx,edx
;add		edi,sizeof	EntryHeader
mov		eax,1
mov		[edx].HeaderID,eax
mov		ebx,DataHandle
mov		edi,edx
sub		edi,ebx
add		edi,sizeof	EntryHeader
mov		[edx].NextEntry,edi
add		edx,[edx].NextEntry

push	edx
invoke	InverseCopy,Name2,addr [edx].ScientificName
pop		edx
push	edx
invoke	InverseCopy,Name1,addr [edx].NormalName
pop		edx
mov		eax,1
mov		[edx].HeaderID,eax
mov		eax,0
mov		[edx].NextEntry,eax
	ret

NewEntry endp

DoListStartup proc hWin:dword
LOCAL    lvc:LV_COLUMN

INVOKE	CreateWindowEx, WS_EX_CLIENTEDGE, addr ListViewClass, NULL,\
        WS_CHILD or WS_VISIBLE or LVS_REPORT ,\
       	3, 3, 700, 210, hWin, Item_List, hInstance, NULL
mov		Item_List, eax

mov		eax, LVS_EX_FULLROWSELECT or LVS_EX_HEADERDRAGDROP or LVS_EX_GRIDLINES
INVOKE	SendMessage, Item_List, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax

invoke 	CreateFont,20, 0,0,0,600,0,0,0, DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,addr szPapyrus 
mov 	hFont,eax
		
INVOKE  SendMessage,Item_List, 	WM_SETFONT, 	hFont, 	1
INVOKE 	SendMessage,Item_List, 	LVM_SETTEXTCOLOR, 	0, 	00ffff00h
INVOKE	SendMessage,Item_List, 	LVM_SETBKCOLOR, 	0,	0000a000h
INVOKE	SendMessage,Item_List, 	LVM_SETTEXTBKCOLOR, 0, 	0000a000h
 
mov     lvc.imask, LVCF_TEXT or LVCF_WIDTH or LVCF_FMT; or LVCF_SUBITEM	
mov     lvc.fmt, LVCFMT_CENTER
mov     lvc.pszText, offset szColName
mov     lvc.lx, 200
INVOKE  SendMessage,Item_List, LVM_INSERTCOLUMN, 0, addr lvc

mov     lvc.pszText, offset szColSName
mov     lvc.lx, 200
INVOKE  SendMessage,Item_List, LVM_INSERTCOLUMN, 1, addr lvc   
        	
	ret

DoListStartup endp

ReadDataFile proc
LOCAL SizeF,Handle:dword
invoke 	CreateFile,addr DataFileName,GENERIC_READ or GENERIC_WRITE,0,0,OPEN_ALWAYS,0,0
mov 	DataHandle,eax
invoke	GetFileSize,DataHandle,0
add		eax,10
mov		SizeF,eax
;
;
;
;WAS MY PROBLEM HERE???????
;was changing the memmaped file to 1000000 rather than 100000
;it apears to stop quite a few problems :)
;but there's got to be an easier way rathere than having a huge data file that F*** all
; of it gets used. how do i make it run and change the data file size automaticly???
invoke 	CreateFileMapping, DataHandle, NULL,  PAGE_READWRITE,0,1000000,0
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;
;
;
.if eax!=NULL
	mov 	DataHandle, eax
	invoke 	MapViewOfFile,DataHandle,FILE_MAP_ALL_ACCESS,0,0,0
	.if eax!=NULL
		mov		DataHandle,eax
		;invoke	MessageBox,NULL,DataHandle,NULL,MB_OK
		mov		eax,DataHandle
		assume	eax:ptr DataHeader
		mov		edx,[eax].Signiture
		.if	edx == 0
			NewDataBase:
			mov		ebx,'PliD'
			mov		[eax].Signiture, ebx
			mov		ebx, sizeof DataHeader
			inc		ebx
			mov		[eax].SizeFile, ebx
			mov		ebx, 0
			mov		[eax].FirstHeader,ebx
			invoke	InverseCopy,addr PlantSpecDescriptor,addr [eax].Data_Identifier
		.elseif edx == 'PliD'
			invoke	ReadEntrys,DataHandle
			jmp	exitReadData
		.else
			push	eax
			invoke 	MessageBox,NULL,addr CorruptFileErr,NULL,MB_OK
			pop		eax
			jmp		NewDataBase
		.endif



 	.endif

exitReadData:
.endif 
ret

ReadDataFile endp

InverseCopy proc src:DWORD, dst:DWORD

    push edi

    mov edx, src
    mov edi, dst
    xor ecx, ecx

  @@:
    mov al, [edx+ecx]
   ; not	al
    mov [edi+ecx], al
    add ecx, 1
	;cmp al,0ffh
	cmp	al,0
    jne @B

    pop edi

    ret

InverseCopy endp

ReadEntrys proc Data:dword
LOCAL	str1,str2:dword,TempEDX:dword

mov		edx,Data
assume 	edx:ptr DataHeader
mov		eax,[edx].FirstHeader

mov		ebx,eax

.if	eax == 0
	ret
.endif	

add		edx,ebx
assume	edx:ptr EntryHeader
mov		eax,[edx].HeaderID
mov		TempEDX,edx

.if eax != 1
	invoke 	MessageBox,NULL,addr CorruptFileErr,NULL,MB_OK
	ret
.endif

@@:	


mov		edx,TempEDX
add		edx,[edx].NextEntry	
mov		TempEDX,edx

invoke	SysAllocStringByteLen,64,0
mov		str2,eax
invoke	SysAllocStringByteLen,64,0
mov		str1,eax
mov		edx,TempEDX
push	edx
invoke	InverseCopy,addr [edx].NormalName,str1
pop		edx
push	edx
invoke	InverseCopy,addr [edx].ScientificName,str2
pop		edx

invoke	AddListItem,str1,str2

invoke	SysFreeString,str1
invoke	SysFreeString,str2
mov		edx,TempEDX

.if		[edx].NextEntry == 0	
	ret
.endif
jmp	@B
	ret

ReadEntrys endp

MemCopy proc uses esi edi Source:dword,Dest:dword,ln:DWORD

    ; ---------------------------------------------------------
    ; Copy ln bytes of memory from Source buffer to Dest buffer
    ;      ~~                      ~~~~~~           ~~~~
    ; USAGE:
    ; invoke MemCopy,ADDR Source,ADDR Dest,4096
    ;
    ; NOTE: Dest buffer must be at least as large as the source
    ;       buffer otherwise a page fault will be generated.
    ; ---------------------------------------------------------

    cld
    mov esi, Source
    mov edi, Dest
    mov ecx, ln

    shr ecx, 2
    rep movsd

    mov ecx, ln
    and ecx, 3
    rep movsb

    ret

MemCopy endp

;SehHandler PROC C pExcept:DWORD,pFrame:DWORD,pContext:DWORD,pDispatch:DWORD

;	MOV  EAX, pContext
;	ASSUME EAX : PTR CONTEXT

;	PUSH SEH.SaveEip
;	POP  [EAX].regEip
;	PUSH SEH.OrgEsp
;	POP  [EAX].regEsp
;	PUSH SEH.OrgEbp
;	POP [EAX].regEbp
;
;	MOV  EAX, ExceptionContinueExecution
;
;	RET
;SehHandler ENDP


end start
