

include  	\MASM32\include\Windows.inc
include		\masm32\include\oleaut32.inc
include  	\MASM32\include\user32.inc
include  	\Masm32\include\gdi32.inc
include  	\MASM32\include\kernel32.inc
include  	\MASM32\include\comctl32.inc
include  	\MASM32\include\imagehlp.inc
include  	\MASM32\include\shell32.inc
include  	\MASM32\include\ole32.inc
include  	\MASM32\include\masm32.inc

includelib  \MASM32\lib\masm32.lib
includelib  \MASM32\lib\user32.lib
includelib  \Masm32\lib\gdi32.lib
includelib  \MASM32\lib\kernel32.lib
includelib  \MASM32\lib\comctl32.lib
includelib  \MASM32\LIB\imagehlp.LIB
includelib  \MASM32\lib\shell32.lib
includelib  \MASM32\lib\ole32.lib
includelib	\MASM32\lib\oleaut32.lib

DlgProc					PROTO	:HWND,:UINT,:WPARAM,:LPARAM
DoListStartup			PROTO  	:DWORD
ReadDataFile			proto
InverseCopy 			PROTO 	:DWORD,:DWORD
ReadEntrys				proto	:dword
NewEntry				PROTO	:DWORD,:DWORD
AddListItem				PROTO	:DWORD,:DWORD
MemCopy					PROTO	:dword,:dword,:DWORD


DataHeader Struct 
	Signiture	dd	?
	SizeFile	dd	?
	FirstHeader	dd	?
	Data_Identifier db 64 DUP (?)
DataHeader ends

EntryHeader Struct
	HeaderID	dd ?
	NextEntry	dd ?
	NormalName	db 64 dup (?)
	ScientificName	db 64 dup (?)
	CamparitableInfo	dd 4096 dup (?)
	Pictureaddr	dd ?
	PictureSize	dd ?
EntryHeader ends

sSEH STRUCT
	OrgEsp            DD ?
	OrgEbp            DD ?
	SaveEip           DD ?
sSEH ENDS

;---- MACROs ----
InstSehFrame MACRO ContinueAddr
	ASSUME FS : NOTHING
	
   IFNDEF  SehStruct
        SehStruct EQU 1
     	.DATA
     	SEH    sSEH <>
   ENDIF
   
	.CODE
	MOV  SEH.SaveEip, ContinueAddr
	MOV  SEH.OrgEbp, EBP
	PUSH OFFSET SehHandler
	PUSH FS:[0]
	MOV  SEH.OrgEsp, ESP
	MOV  FS:[0], ESP
ENDM

KillSehFrame MACRO
	POP  FS:[0]
	ADD  ESP, 4
ENDM

.const
MainDLG							equ 1000
New_Record						equ 1001
IDC_EDT1						equ 1002
IDC_EDT2						equ 1003

;#########################################################################
.data
ListViewClass     	db        	'SysListView32',0
szPapyrus         	db        	'Papyrus',0
Item_List		  	dd 		  	5000
szColName         	db        	'Common Name',0
szColSName        	db        	'Scientific Name',0
CorruptFileErr		db			'The Database is Corrupt',0
DataFileName		db			'Data.txt',0
PlantSpecDescriptor	db			'Plant Identifier Toowoomba State High. Writen By Lewis Lakerink',0

.data?
hFont				dd 		 	?
DataHandle			dd			?
hInstance			dd ?
tvar				db	1000	dup (?)
;#########################################################################
